#version 150

uniform sampler2D bloomTexture;

in vec2 fragmentTexCoord;

out vec4 fragColor;

void main(void) {
	vec4 texColor = texture2D(bloomTexture, fragmentTexCoord);
	float threshold = 0.4;
	float r, g, b;

	
	//Heavy white bloom
	if (texColor.r > threshold && texColor.g > threshold && 			texColor.b > threshold) {
		fragColor = texColor;
	}
	else {
		fragColor = vec4(0.0, 0.0, 0.0, 1.0);
	}
	

	r = max(texColor.r - threshold, 0);
	g = max(texColor.g - threshold, 0);
	b = max(texColor.b - threshold, 0);
/*
if (r > 0) {
		r = r + 0.4;
	}
	if (g > 0) {
		g = g + 0.4;
	}
	if (b > 0) {
		b = b + 0.4;
	}

*/
	fragColor = vec4(r, g, b, 1.0);
	//fragColor = vec4(0.0, 0.0, 0.0, 1.0);
}
