#version 150

uniform sampler2D bloomTexture;
uniform vec2 shift;

in vec2 fragmentTexCoord;

out vec4 fragColor;


//Values calculated using a one-dimensional Gauss-function
//(x = -5 ... 5, sigma = 3.2)
const int gaussRadius = 11;
const float gaussFilter[gaussRadius] = float[gaussRadius](
		0.0402,0.0623,0.0877,0.1120,0.1297,0.1362,0.1297,
		0.1120,0.0877,0.0623,0.0402);

void main(void) {
	vec2 texCoord = fragmentTexCoord.xy - float(int					(gaussRadius / 2)) * shift;
	vec3 color = vec3(0.0, 0.0, 0.0); 
	
	for (int i = 0; i < gaussRadius; ++i) { 
		color += gaussFilter[i] * texture2D(bloomTexture, 					texCoord).xyz;
		texCoord += shift;
	}

	fragColor = vec4(color, 1.0);	
}
