#version 150

//Uniform shader-parameters
uniform mat4 view;
uniform mat4 model;

//Uniform shader-parameters
uniform mat4 ViewModel;
uniform mat4 ProjViewModel;
uniform mat4 TexModel;
uniform float useNormalMap;
uniform vec3 lightPosition;


//Attributes
in vec4 vertex;
in vec3 normal;
in vec2 texCoord;
in vec3 tangent;
in vec3 bitangent;


out vec3 worldNormal;
out vec4 worldPosition;
out vec2 fragmentTexCoord;
out vec4 viewPosition;

out float specularExp;
out vec3 tangentSpace;
out vec3 bitangentSpace;
out vec3 camVec;




// shadow
out vec4 ShadowCoord; 

void main(void)
{
	fragmentTexCoord = texCoord;

	//Transform normal to world-space
	worldNormal = normalize((model * vec4(normal, 0.0f)).xyz );
	tangentSpace  = normalize((model * vec4(tangent,0.0f)).xyz);
	bitangentSpace  = normalize((model * vec4(bitangent,0.0f)).xyz);
	
	 camVec = vec3(view[0][2],view[1][2],view[2][2]);
	vec3 viewDir = normalize(camVec - (-worldNormal));
	vec3 lightDir = normalize(lightPosition - worldNormal);
	
	if(useNormalMap != 0.0){
		 
	 
	}

		//Transform vertex to view(eye)-space
		viewPosition = ViewModel * vertex;

		//Transform vertex to world-space
	    worldPosition = model * vertex;

		// transform shadow coords
	    ShadowCoord = TexModel  * worldPosition; 
	  	
		//Transform vertex down the pipeline
		gl_Position = ProjViewModel * vertex;
		
	////////Temp


	////////
}


