#version 150

//Uniform shader-parameters
uniform mat4 view;
uniform mat4 model;
uniform mat4 ProjViewModel;

//Attributes
in vec4 vertex;
in vec3 normal;
in vec2 texCoord;
in vec3 tangent;
in vec3 bitangent;


out vec3 worldNormal;
out vec4 worldPosition;
out vec2 fragmentTexCoord;


void main(void)
{
	fragmentTexCoord = texCoord;
if (tangent.x > 0.0f && bitangent.x > 0.0f){
		
	}
	//Transform normal to world-space
	worldNormal = (model * vec4(normal, 0.0f)).xyz;

	//Transform vertex to world-space
    worldPosition = model * vertex;

	//Transform vertex down the pipeline
	gl_Position = ProjViewModel * vertex;


}


