#version 150

//Uniform shader-parameters
uniform mat4 view;
uniform mat4 model;

//Uniform shader-parameters
uniform mat4 ViewModel;
uniform mat4 ProjViewModel;
uniform mat4 TexModel;

//Attributes
in vec4 vertex;
in vec3 normal;
in vec2 texCoord;
// use to "align" object with viewer
in vec3 tangent;
in vec3 bitangent;

in float elapsedTime;
in float swayStrength; 

out vec3 worldNormal;
out vec4 worldPosition;
out vec2 fragmentTexCoord;
out vec4 viewPosition;


// shadow
out vec4 ShadowCoord; 

void main(void)
{
	fragmentTexCoord = texCoord;

	//Transform normal to world-space
	worldNormal = normalize((model * vec4(normal, 0.0f)).xyz);

	vec3 camVec = vec3(view[0][2],view[1][2],view[2][2]);
	vec3 viewDir = normalize(camVec - (-worldNormal));
	
	if(tangent.x > 0.0){
		
	}

	//Grass movement
	vec4 temp = vertex;

if (texCoord.y > 0.8f) {
			float wave = cos(elapsedTime) * swayStrength;

			temp.x += wave;
			temp.y += wave;
}


	//Transform vertex to view(eye)-space
	viewPosition = ViewModel * temp;

	//Transform vertex to world-space
    worldPosition = model * temp;

	// transform shadow coords
	ShadowCoord = TexModel  * worldPosition; 


	//Transform vertex down the pipeline
	gl_Position = ProjViewModel * temp ;

	////////Temp


	////////

}


