#version 150

//Uniform shader-parameters
uniform mat4 view;
uniform mat4 model;
uniform mat4 ProjViewModel;

//Attributes
in vec4 vertex;
in vec3 normal;
in vec2 texCoord;
in float elapsedTime;
in float swayStrength; 

// use to "align" object with viewer
in vec3 tangent;
in vec3 bitangent;

out vec3 worldNormal;
out vec4 worldPosition;
out vec2 fragmentTexCoord;


void main(void)
{
	fragmentTexCoord = texCoord;


	//Transform normal to world-space
	worldNormal = (model * vec4(normal, 0.0f)).xyz;

	//Transform vertex to world-space
    worldPosition = model * vertex;

	//Grass movement
	vec4 temp = vertex;

	if(tangent.x > 0.0){
		
	}

	if (texCoord.y > 0.8f) {
			float wave = cos(elapsedTime) * swayStrength;

			temp.x += wave;
			temp.z += wave;
	}
	
	//Transform vertex down the pipeline
	gl_Position = ProjViewModel * temp ;


}


